from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, File, Int

Livekraken_Build_V0_1_0 = CommandToolBuilder(tool="livekraken_build", base_command=["livekraken-build"], inputs=[ToolInput(tag="in_download_taxonomy", input_type=Boolean(optional=True), prefix="--download-taxonomy", doc=InputDocumentation(doc="Download NCBI taxonomic information")), ToolInput(tag="in_download_library", input_type=String(optional=True), prefix="--download-library", doc=InputDocumentation(doc="Download partial library\n(TYPE = one of 'bacteria', 'plasmids',\n'viruses', 'human')")), ToolInput(tag="in_add_to_library", input_type=File(optional=True), prefix="--add-to-library", doc=InputDocumentation(doc="Add FILE to library")), ToolInput(tag="in_build", input_type=Boolean(optional=True), prefix="--build", doc=InputDocumentation(doc="Create DB from library\n(requires taxonomy d/l'ed and at least one file\nin library)")), ToolInput(tag="in_rebuild", input_type=Boolean(optional=True), prefix="--rebuild", doc=InputDocumentation(doc="Create DB from library like --build, but remove\nexisting non-library/taxonomy files before build")), ToolInput(tag="in_clean", input_type=Boolean(optional=True), prefix="--clean", doc=InputDocumentation(doc="Remove unneeded files from a built database")), ToolInput(tag="in_shrink", input_type=String(optional=True), prefix="--shrink", doc=InputDocumentation(doc="Shrink an existing DB to have only NEW_CT k-mers")), ToolInput(tag="in_standard", input_type=Boolean(optional=True), prefix="--standard", doc=InputDocumentation(doc="Download and create default database")), ToolInput(tag="in_upgrade", input_type=Boolean(optional=True), prefix="--upgrade", doc=InputDocumentation(doc="Upgrade an existing older database to use scrambled\nminimizer ordering (see README for details)")), ToolInput(tag="in_db", input_type=String(optional=True), prefix="--db", doc=InputDocumentation(doc="Kraken DB/library name (mandatory except for")), ToolInput(tag="in_threads", input_type=Boolean(optional=True), prefix="--threads", doc=InputDocumentation(doc="#                Number of threads (def: 1)")), ToolInput(tag="in_new_db", input_type=String(optional=True), prefix="--new-db", doc=InputDocumentation(doc="New Kraken DB name (shrink task only; mandatory\nfor shrink task)")), ToolInput(tag="in_km_er_len", input_type=Int(optional=True), prefix="--kmer-len", doc=InputDocumentation(doc="K-mer length in bp (build/shrink tasks only;\ndef: 31)")), ToolInput(tag="in_minimizer_len", input_type=Int(optional=True), prefix="--minimizer-len", doc=InputDocumentation(doc="Minimizer length in bp (build/shrink tasks only;\ndef: 15)")), ToolInput(tag="in_jellyfish_hash_size", input_type=Int(optional=True), prefix="--jellyfish-hash-size", doc=InputDocumentation(doc="Pass a specific hash size argument to jellyfish\nwhen building database (build task only)")), ToolInput(tag="in_max_db_size", input_type=Int(optional=True), prefix="--max-db-size", doc=InputDocumentation(doc="Shrink the DB before full build, making sure\ndatabase and index together use <= SIZE gigabytes\n(build task only)")), ToolInput(tag="in_shrink_block_offset", input_type=Int(optional=True), prefix="--shrink-block-offset", doc=InputDocumentation(doc="When shrinking, select the k-mer that is NUM\npositions from the end of a block of k-mers\n(default: 1)")), ToolInput(tag="in_work_on_disk", input_type=Boolean(optional=True), prefix="--work-on-disk", doc=InputDocumentation(doc="Perform most operations on disk rather than in\nRAM (will slow down build in most cases)\n")), ToolInput(tag="in_task", input_type=String(optional=True), position=0, doc=InputDocumentation(doc=""))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Livekraken_Build_V0_1_0().translate("wdl", allow_empty_container=True)

